"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Generic_1 = require("./Generic");
var DirectTree_1 = require("./DirectTree");
var DirectMath;
(function (DirectMath) {
    /** Extend 1d number function to Numeric Object */
    function Apply1D(f, operand) {
        return DirectTree_1.DirectTree.OperateLeafExternal(operand, f);
    }
    DirectMath.Apply1D = Apply1D;
    function Abs(operand) {
        return Apply1D(Math.abs, operand);
    }
    DirectMath.Abs = Abs;
    function Acos(operand) {
        return Apply1D(Math.acos, operand);
    }
    DirectMath.Acos = Acos;
    function Acosh(operand) {
        return Apply1D(Math.acosh, operand);
    }
    DirectMath.Acosh = Acosh;
    function Asin(operand) {
        return Apply1D(Math.asin, operand);
    }
    DirectMath.Asin = Asin;
    function Asinh(operand) {
        return Apply1D(Math.asinh, operand);
    }
    DirectMath.Asinh = Asinh;
    function Atan(operand) {
        return Apply1D(Math.atan, operand);
    }
    DirectMath.Atan = Atan;
    function Atanh(operand) {
        return Apply1D(Math.atanh, operand);
    }
    DirectMath.Atanh = Atanh;
    function Cbrt(operand) {
        return Apply1D(Math.cbrt, operand);
    }
    DirectMath.Cbrt = Cbrt;
    function Ceil(operand) {
        return Apply1D(Math.ceil, operand);
    }
    DirectMath.Ceil = Ceil;
    function Cos(operand) {
        return Apply1D(Math.cos, operand);
    }
    DirectMath.Cos = Cos;
    function Cosh(operand) {
        return Apply1D(Math.cosh, operand);
    }
    DirectMath.Cosh = Cosh;
    function Exp(operand) {
        return Apply1D(Math.exp, operand);
    }
    DirectMath.Exp = Exp;
    function Floor(operand) {
        return Apply1D(Math.floor, operand);
    }
    DirectMath.Floor = Floor;
    function Log(operand) {
        return Apply1D(Math.log, operand);
    }
    DirectMath.Log = Log;
    function Log10(operand) {
        return Apply1D(Math.log10, operand);
    }
    DirectMath.Log10 = Log10;
    function Log2(operand) {
        return Apply1D(Math.log2, operand);
    }
    DirectMath.Log2 = Log2;
    function Sin(operand) {
        return Apply1D(Math.sin, operand);
    }
    DirectMath.Sin = Sin;
    function Sinh(operand) {
        return Apply1D(Math.sinh, operand);
    }
    DirectMath.Sinh = Sinh;
    function Sqrt(operand) {
        return Apply1D(Math.sqrt, operand);
    }
    DirectMath.Sqrt = Sqrt;
    function Tan(operand) {
        return Apply1D(Math.tan, operand);
    }
    DirectMath.Tan = Tan;
    function Tanh(operand) {
        return Apply1D(Math.tanh, operand);
    }
    DirectMath.Tanh = Tanh;
    function Trunc(operand) {
        return Apply1D(Math.trunc, operand);
    }
    DirectMath.Trunc = Trunc;
    /** apply nd number function to Numeric Objects */
    function ApplyND(f) {
        var operands = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            operands[_i - 1] = arguments[_i];
        }
        var objectIndex = operands.findIndex(function (o) { return !Generic_1.Generic.IsNumber(o); });
        if (objectIndex > -1) {
            var reference_1 = operands[objectIndex];
            var ops = operands.map(function (o) { return (Generic_1.Generic.IsNumber(o) ? Generic_1.Generic.Assign(reference_1, o) : o); });
            return DirectTree_1.DirectTree.OperateLeafExternal.apply(DirectTree_1.DirectTree, [ops[0], f].concat(ops.slice(1)));
        }
        return {};
    }
    function Max() {
        var operands = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            operands[_i] = arguments[_i];
        }
        return ApplyND.apply(void 0, [Math.max].concat(operands));
    }
    DirectMath.Max = Max;
    function Min() {
        var operands = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            operands[_i] = arguments[_i];
        }
        return ApplyND.apply(void 0, [Math.min].concat(operands));
    }
    DirectMath.Min = Min;
    function minmax() {
        var values = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            values[_i] = arguments[_i];
        }
        var min = values[0];
        var max = values[0];
        for (var i = 1; i < values.length; ++i) {
            var val = values[i];
            if (val > max) {
                max = val;
            }
            else if (val < min) {
                min = val;
            }
        }
        return [min, max];
    }
    DirectMath.minmax = minmax;
    function absoluteMax() {
        var values = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            values[_i] = arguments[_i];
        }
        var absolutes = values.map(function (value) { return Math.abs(value); });
        var value = Math.max.apply(Math, absolutes);
        return values[absolutes.indexOf(value)];
    }
    DirectMath.absoluteMax = absoluteMax;
    function AbsoluteMax() {
        var operands = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            operands[_i] = arguments[_i];
        }
        return ApplyND.apply(void 0, [absoluteMax].concat(operands));
    }
    DirectMath.AbsoluteMax = AbsoluteMax;
    function average() {
        var values = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            values[_i] = arguments[_i];
        }
        return sum.apply(void 0, values) / values.length;
    }
    DirectMath.average = average;
    function Average() {
        var operands = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            operands[_i] = arguments[_i];
        }
        return ApplyND.apply(void 0, [average].concat(operands));
    }
    DirectMath.Average = Average;
    function bound(value, min, max) {
        return Math.max(min, Math.min(max, value));
    }
    DirectMath.bound = bound;
    function Bound(operand, min, max) {
        return ApplyND(bound, operand, min, max);
    }
    DirectMath.Bound = Bound;
    function round(value, precision) {
        if (precision === void 0) { precision = 1; }
        return Math.round(value / precision) * precision;
    }
    DirectMath.round = round;
    function Round(operand, precision) {
        if (precision === void 0) { precision = 1; }
        return ApplyND(round, operand, precision);
    }
    DirectMath.Round = Round;
    function sum() {
        var values = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            values[_i] = arguments[_i];
        }
        return values.reduce(function (val1, val2) { return val1 + val2; });
    }
    DirectMath.sum = sum;
    function Sum() {
        var operands = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            operands[_i] = arguments[_i];
        }
        return ApplyND.apply(void 0, [sum].concat(operands));
    }
    DirectMath.Sum = Sum;
    function variance() {
        var values = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            values[_i] = arguments[_i];
        }
        var mean = average.apply(void 0, values);
        return average.apply(void 0, values.map(function (val) { return (val - mean) * (val - mean); }));
    }
    DirectMath.variance = variance;
    function Variance() {
        var operands = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            operands[_i] = arguments[_i];
        }
        return ApplyND.apply(void 0, [variance].concat(operands));
    }
    DirectMath.Variance = Variance;
    function Add() {
        var operands = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            operands[_i] = arguments[_i];
        }
        return ApplyND.apply(void 0, [sum].concat(operands));
    }
    DirectMath.Add = Add;
    function subtract() {
        var values = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            values[_i] = arguments[_i];
        }
        return values.reduce(function (val1, val2) { return val1 - val2; });
    }
    DirectMath.subtract = subtract;
    function Subtract() {
        var operands = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            operands[_i] = arguments[_i];
        }
        return ApplyND.apply(void 0, [subtract].concat(operands));
    }
    DirectMath.Subtract = Subtract;
    function multiply() {
        var values = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            values[_i] = arguments[_i];
        }
        return values.reduce(function (val1, val2) { return val1 * val2; });
    }
    DirectMath.multiply = multiply;
    function Multiply() {
        var operands = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            operands[_i] = arguments[_i];
        }
        return ApplyND.apply(void 0, [multiply].concat(operands));
    }
    DirectMath.Multiply = Multiply;
    function divide() {
        var values = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            values[_i] = arguments[_i];
        }
        return values.reduce(function (val1, val2) { return val1 / val2; });
    }
    DirectMath.divide = divide;
    function Divide() {
        var operands = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            operands[_i] = arguments[_i];
        }
        return ApplyND.apply(void 0, [divide].concat(operands));
    }
    DirectMath.Divide = Divide;
})(DirectMath = exports.DirectMath || (exports.DirectMath = {}));
//# sourceMappingURL=DirectMath.js.map