import { DirectTreeObject } from './DirectTree';
export declare type NumericObject = DirectTreeObject<number>;
export declare type NumericOperand = number | NumericObject;
export declare namespace DirectMath {
    /** Extend 1d number function to Numeric Object */
    function Apply1D<T extends NumericObject>(f: (operand: number) => number, operand: T): T;
    function Abs<T extends NumericObject>(operand: T): T;
    function Acos<T extends NumericObject>(operand: T): T;
    function Acosh<T extends NumericObject>(operand: T): T;
    function Asin<T extends NumericObject>(operand: T): T;
    function Asinh<T extends NumericObject>(operand: T): T;
    function Atan<T extends NumericObject>(operand: T): T;
    function Atanh<T extends NumericObject>(operand: T): T;
    function Cbrt<T extends NumericObject>(operand: T): T;
    function Ceil<T extends NumericObject>(operand: T): T;
    function Cos<T extends NumericObject>(operand: T): T;
    function Cosh<T extends NumericObject>(operand: T): T;
    function Exp<T extends NumericObject>(operand: T): T;
    function Floor<T extends NumericObject>(operand: T): T;
    function Log<T extends NumericObject>(operand: T): T;
    function Log10<T extends NumericObject>(operand: T): T;
    function Log2<T extends NumericObject>(operand: T): T;
    function Sin<T extends NumericObject>(operand: T): T;
    function Sinh<T extends NumericObject>(operand: T): T;
    function Sqrt<T extends NumericObject>(operand: T): T;
    function Tan<T extends NumericObject>(operand: T): T;
    function Tanh<T extends NumericObject>(operand: T): T;
    function Trunc<T extends NumericObject>(operand: T): T;
    function Max<T extends NumericObject>(...operands: (number | T)[]): T;
    function Min<T extends NumericObject>(...operands: (number | T)[]): T;
    function minmax(...values: number[]): [number, number];
    function absoluteMax(...values: number[]): number;
    function AbsoluteMax<T extends NumericObject>(...operands: (number | T)[]): T;
    function average(...values: number[]): number;
    function Average<T extends NumericObject>(...operands: (number | T)[]): T;
    function bound(value: number, min: number, max: number): number;
    function Bound<T extends NumericObject>(operand: T, min: (number | T), max: (number | T)): T;
    function round(value: number, precision?: number): number;
    function Round<T extends NumericObject>(operand: T, precision?: (number | T)): T;
    function sum(...values: number[]): number;
    function Sum<T extends NumericObject>(...operands: (number | T)[]): T;
    function variance(...values: number[]): number;
    function Variance<T extends NumericObject>(...operands: (number | T)[]): T;
    function Add<T extends NumericObject>(...operands: (number | T)[]): T;
    function subtract(...values: number[]): number;
    function Subtract<T extends NumericObject>(...operands: (number | T)[]): T;
    function multiply(...values: number[]): number;
    function Multiply<T extends NumericObject>(...operands: (number | T)[]): T;
    function divide(...values: number[]): number;
    function Divide<T extends NumericObject>(...operands: (number | T)[]): T;
}
