export declare namespace Generic {
    interface NonEmptyObject {
        [index: string]: unknown;
    }
    /**
     * Find the common value of provided array; for object array, first object is used as key reference, only property with common parts has key in result object.
     */
    function Common<T>(values: T[], eps?: number): T | null;
    function IsArray(target: any): target is any[];
    function IsObject(target: any): target is object;
    function IsNumber(target: any): target is number;
    function IsPlainObject(target: any): boolean;
    function IsString(target: any): target is string;
    function IsInstance(target: any): boolean;
    /**
     * IsEmpty() determines whether the target is empty (array of zero length, object without any property, string of zero length, null, undefined or class without any members).
     */
    function IsEmpty(target: any): boolean;
    /**
     * Clone() makes a deep/shallow value copy of given object.
     */
    function Clone<T>(target: T, deep?: boolean): T;
    /** Null() return a null version of give object or value. e.g. 1 => null; {a : { b : 1 } } = > { a: { b: null } } */
    function Null(target: unknown): any;
    /** Assign() return version of and index copy of given object or value filled with specified value. e.g. (1, v) => v; ({a : { b : 1 } }, v) = > { a: { b: v } } */
    function Assign(target: unknown, value: unknown): unknown;
    /**
     * Equals() does value compare for two arbitrary operands.
     */
    function Equals(o1: unknown, o2: unknown, eps?: number): boolean;
}
